package cn.iocoder.yudao.module.member.service.memberUserScore;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.service.AbstractService;
import cn.iocoder.yudao.module.member.dal.dataobject.memberUserScore.MemberUserScoreDO;
import cn.iocoder.yudao.module.member.dal.mysql.memberUserScore.MemberUserScoreMapper;
import cn.iocoder.yudao.module.member.vo.memberUserScore.MemberUserScoreBackVO;
import cn.iocoder.yudao.module.member.vo.memberUserScore.MemberUserScoreQueryVO;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.util.Collection;
import java.util.List;

/**
 * 会员积分 Service 实现类
 *
 * @author 系统管理员
 */
@Service
@Validated
public class MemberUserScoreServiceImpl extends AbstractService<MemberUserScoreMapper, MemberUserScoreDO> implements MemberUserScoreService {

    @Resource
    private MemberUserScoreMapper userScoreMapper;

    @Override
    public void deleteUserScore(Long id) {
        // 删除
        userScoreMapper.deleteById(id);
    }

    @Override
    public MemberUserScoreDO getUserScore(Long id) {
        return userScoreMapper.selectById(id);
    }

    @Override
    public List<MemberUserScoreDO> getUserScoreList(Collection<Long> ids) {
        return userScoreMapper.selectBatchIds(ids);
    }

    @Override
    public PageResult<MemberUserScoreBackVO> getUserScorePage(MemberUserScoreQueryVO query) {
        int start = (query.getPageNo() - 1) * query.getPageSize();
        int size = query.getPageSize();
        List<MemberUserScoreBackVO> list = userScoreMapper.getUserScoreList(start, size, query);
        int total = userScoreMapper.countUserScore(query);
        return new PageResult<>(list, total, query.getPageSize(), query.getPageNo(), (total + query.getPageSize() - 1) / query.getPageSize());
    }

    @Override
    public List<MemberUserScoreDO> getUserScoreList(MemberUserScoreQueryVO query) {
        return userScoreMapper.selectList(query);
    }
}
